close all;
clear all;

addpath([cd '/utilies']);


% load ORL_32x32;
load ORL_32x32_10b;


train_num = 5;

for i = 1:size(fea,1)
    fea(i,:) = fea(i,:)/norm(fea(i,:));
end

opt_dim = [];
time = [];

rate_all = [];

for loop = 1
    tic;
    load(strcat('ORL_5Train/',num2str(loop),'.mat'))
    tr_dat = fea(trainIdx,:)';
    tt_dat = fea(testIdx,:)';
    
    trls = gnd(trainIdx)';
    ttls = gnd(testIdx)';
    for i = 1:size(tr_dat,2)
        tr_dat(:,i) = tr_dat(:,i)/norm(tr_dat(:,i));
    end
    for i = 1:size(tt_dat,2)
        tt_dat(:,i) = tt_dat(:,i)/norm(tt_dat(:,i));
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%%
    %DLR parameter
    %%%%%%%%%%%%%%%%%%%%%%%%
    opts.nClass        =   40;
    opts.wayInit       =   'PCA';
    opts.lambda1       =   0.02;
    opts.lambda2       =   0.05;
    opts.nIter         =   2;
    opts.show          =   false;
    
    [Dict,Drls,CoefM,CMlabel] = DLR(tr_dat,trls,opts);
    
    
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Classification
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    a=1;
    b1=1;
    ID = [];
    D = Dict;
    ni = size(tr_dat,2)/opts.nClass;
    for i = 1:size(tt_dat,2)
        yi = tt_dat(:,i);
        [x, e] = UpdateXi(yi,D,a,b1);
        y = [];
        for j = 1:opts.nClass
            x_new = zeros(size(x));
            x_new((j-1)*ni+1:j*ni) = x((j-1)*ni+1:j*ni);
            y(j) = norm(yi - D*x_new - e);
        end
        [v ID(i)] = min(y);
        y = [];
    end
    
    rate_all = [rate_all sum(ID==ttls)/(length(ttls))]
end
rate_all
rate_mean = mean(rate_all)
rate_std = std(rate_all)