function [X,tElapsed,sparsity]=KSRSC(AtA,AtB,BtB,option)
% kernel sparse coding B=AX
% Yifeng Li
% Feb. 10, 2012

tStart=tic;
optionDefault.lambda=0.1;
optionDefault.SRMethod='nnls';
optionDefault.kernel='rbf';
optionDefault.param=[];
optionDefault.iter=200;
optionDefault.dis=1;
optionDefault.residual=1e-6;
optionDefault.tof=1e-6;
if nargin<3
    option=optionDefault;
else
    option=mergeOption(option,optionDefault);
end

switch option.SRMethod
    case 'l1ls'
        X=l1LSKernelBatchDL(AtA,AtB,BtB,option);
    case 'l1qpAs'
        X=l1QP(AtA,-AtB,option.lambda);
    case 'nnls'
        X=NNLSKernelBatchDL(AtA,AtB,BtB,option);
    case 'l1nnls'
        X=l1NNLSKernelBatchDL(AtA,AtB,BtB,option);
end
sparsity=computeSparsity(X);
tElapsed=toc(tStart);
end