function [Xi, Ei] =  UpdateXi(Yi,D,a,b)
tol = 1e-8;
maxIter = 1e6;
[d ni] = size(Yi);
[d m] = size(D);
rho = 1.1;
max_mu = 1e30;
mu = 1e-6;
inv_a = inv(D'*D+eye(m));
%% Initializing optimization variables
% intialize
H = zeros(m,ni);
Xi = zeros(m,ni);
Ei = sparse(d,ni);

T1 = zeros(m,ni);
T2 = zeros(d,ni);
%% Start main loop
iter = 0;
while iter<maxIter
    iter = iter + 1;
    %update H
    temp = Xi + T1/mu;
    H = max(0, temp - a/mu) + min(0, temp + a/mu);
    
    %udpate Z
    Xi = inv_a*(H+D'*Yi-D'*Ei+(D'*T2-T1)/mu);
    
    %update E
    xmaz = Yi-D*Xi;
    temp = xmaz+T2/mu;
    Ei = max(0,temp - b/mu)+min(0,temp + b/mu);
    
    leq1 = xmaz-Ei;
    leq2 = Xi-H;
    stopC = max(max(max(abs(leq1))),max(max(abs(leq2))));
%     if iter==1 || mod(iter,50)==0 || stopC<tol
%         disp(['iter ' num2str(iter) ',mu=' num2str(mu,'%2.1e') ...
%             ',rank=' num2str(rank(Z,1e-3*norm(Z,2))) ',stopALM=' num2str(stopC,'%2.3e')]);
%     end
    if stopC<tol
%         disp('Xi Updated.');
        break;
    else
        T1 = T1 + mu*leq2;
        T2 = T2 + mu*leq1;
        mu = min(max_mu,mu*rho);
    end
end